module Pacman
  # ghosts viewer
  class GhostsRenderer
    def initialize(window, rel_path = '')
      @blinky = { left: Gosu::Image.load_tiles(window, rel_path + 'media/blinky_left.png',
                                               50, 50, false),
                  right: Gosu::Image.load_tiles(window, rel_path + 'media/blinky_right.png',
                                                50, 50, false),
                  up: Gosu::Image.load_tiles(window, rel_path + 'media/blinky_up.png',
                                             50, 50, false),
                  down: Gosu::Image.load_tiles(window, rel_path + 'media/blinky_down.png',
                                               50, 50, false)
      }

      @pinky = { left: Gosu::Image.load_tiles(window, rel_path + 'media/pinky_left.png',
                                              50, 50, false),
                 right: Gosu::Image.load_tiles(window, rel_path + 'media/pinky_right.png',
                                               50, 50, false),
                 up: Gosu::Image.load_tiles(window, rel_path + 'media/pinky_up.png',
                                            50, 50, false),
                 down: Gosu::Image.load_tiles(window, rel_path + 'media/pinky_down.png',
                                              50, 50, false)
      }

      @inky = { left: Gosu::Image.load_tiles(window, rel_path + 'media/inky_left.png',
                                             50, 50, false),
                right: Gosu::Image.load_tiles(window, rel_path + 'media/inky_right.png',
                                              50, 50, false),
                up: Gosu::Image.load_tiles(window, rel_path + 'media/inky_up.png',
                                           50, 50, false),
                down: Gosu::Image.load_tiles(window, rel_path + 'media/inky_down.png',
                                             50, 50, false)
      }

      @clyde = { left: Gosu::Image.load_tiles(window, rel_path + 'media/clyde_left.png',
                                              50, 50, false),
                 right: Gosu::Image.load_tiles(window, rel_path + 'media/clyde_right.png',
                                               50, 50, false),
                 up: Gosu::Image.load_tiles(window, rel_path + 'media/clyde_up.png',
                                            50, 50, false),
                 down: Gosu::Image.load_tiles(window, rel_path + 'media/clyde_down.png',
                                              50, 50, false)
      }
    end

    def render(level, _state, next_frame)
      if next_frame
        ghosts = level.ghosts
        [ghosts[:blinky], ghosts[:pinky], ghosts[:inky], ghosts[:clyde]].each do |ghost|
          ghost.animation_index = (ghost.animation_index + 1) % @blinky[:left].size
        end
      end

      # render ghosts
      render_ghost(level.ghosts[:blinky], @blinky)
      render_ghost(level.ghosts[:pinky], @pinky)
      render_ghost(level.ghosts[:inky], @inky)
      render_ghost(level.ghosts[:clyde], @clyde)
    end

    private

    def render_ghost(ghost_model, ghost_graphics)
      x = LevelRenderer.x_min + ghost_model.x * LevelRenderer.field_size
      y = LevelRenderer.y_min + ghost_model.y * LevelRenderer.field_size
      ghost_graphics[ghost_model.direction][ghost_model.animation_index]
        .draw(x, y, 1)
    end
  end
end
