module Pacman
  # main model class
  class Level
    def initialize
      resize(0, 0)
      @player = nil
      @pellet_count = 0
      @pellets_left = 0
      @ghosts = {}
      @ghosts_frozen = 0
    end

    def resize(width, height)
      @width = width
      @height = height

      # resize array
      @rows = []

      0.upto(height - 1) do
        row = []
        0.upto(width - 1) do
          row << nil
        end
        @rows << row
      end
    end

    def [](key)
      @rows[key]
    end

    def []=(key, value)
      @rows[key] = value
    end

    def get(x, y)
      @rows[y][x]
    end

    def each
      return @rows.each unless block_given?
      @rows.each do |row|
        yield row
      end
    end

    def register_player(_player)
    end

    def each_with_position
      @rows.each_with_index do |row, y|
        row.each_with_index do |col, x|
          yield x, y, col
        end
      end
    end

    attr_accessor :width, :height, :player, :pellet_count, :pellets_left,
                  :cage_obj, :ghosts, :ghosts_frozen
  end
end
